{-# LANGUAGE GeneralizedNewtypeDeriving #-}

module MainLoop ( MainState(..)
                , MainT(..)
                , Main
                , runMain
                ) where

import Game
import GLDriver
import Player

import Control.Monad.State
import Control.Monad.Trans
import Data.Time


data MainState = MainState
               { run      :: !Bool
               , driver   :: !SomeDriver
               , time     :: !UTCTime
               , players  :: ![SomePlayer]
               }

newtype MainT m a = MainT (StateT MainState m a)
    deriving (Monad, MonadState MainState, MonadIO, MonadTrans)

type Main = MainT Game

runMain :: MainState -> Main a -> Game (a, MainState)
runMain st (MainT a) = runStateT a st
